// HSV from customfx reshade
  /*-----------------------.
  | ::     Settings     :: |
  '-----------------------*/
/*
// MAY BE SAFELY MOVED TO THE END OF SweetFX_settings.txt FOR CONVINIENCE.
//>HSV Settings<\\
#define fColorSaturationMod 0 //[-1.00:1.00] //-Adds to the overall color saturation.
#define fColorSaturationMult 1 //[0.00:5.00] //-Multiplies the color saturation.
#define fColorSaturationPow 1 //[0.00:5.00] //-Curves the color saturation.
#define fColorIntensityMod 0 //[-1.00:1.00] //-Adds to the overall brightness.
#define fColorIntensityMult 1 //[0.00:5.00] //-Multiplies the overall brightness.
#define fColorIntensityPow 1 //[0.00:5.00] //-Curves the overall brightness.
#define fColorHueMod 0 //[-1.00:1.00] //-Adds to the overall color hue (color shifting).
#define fColorHueMult 1 //[0.00:5.00] //-Multiplies the color hue (color shifting).
#define fColorHuePow 1 //[0.00:5.00] //-Curves the color hue. 

//>Add Settings<\\
#define fSaturationSatModRed 0 //[-1.00:1.00] //-Adds to the color saturation of red hues only. Default 0.0.
#define fSaturationModOrange 0.09 //[-1.00:1.00] //-Adds to the color saturation of orange hues only. Default 0.0.
#define fSaturationModYellow 0.07 //[-1.00:1.00] //-Adds to the color saturation of yellow hues only. Default 0.0.
#define fSaturationModGreen 0 //[-1.00:1.00] //-Adds to the color saturation of green hues only. Default 0.0. 
#define fSaturationModCyan 0.04 //[-1.00:1.00] //-Adds to the color saturation of cyan hues only. Default 0.0.
#define fSaturationModBlue 0 //[-1.00:1.00] //-Adds to the color saturation of blue hues only. Default 0.0.
#define fSaturationModMagenta 0 //[-1.00:1.00] //-Adds to the color saturation of magenta hues only. Default 0.0.

//>Mult Settings<\\
#define fSaturationMultRed 0 //[0.00:5.00] //-Multiplies the color saturation of red hues only. Default 0.0.
#define fSaturationMultOrange 0 //[0.00:5.00] //-Multiplies the color saturation of orange hues only. Default 0.0.
#define fSaturationMultYellow 0 //[0.00:5.00] //-Multiplies the color saturation of yellow hues only. Default 0.0.
#define fSaturationMultGreen 0 //[0.00:5.00] //-Multiplies the color saturation of green hues only. Default 0.0. 
#define fSaturationMultCyan 0 //[0.00:5.00] //-Multiplies the color saturation of cyan hues only. Default 0.0.
#define fSaturationMultBlue 0 //[0.00:5.00] //-Multiplies the color saturation of blue hues only. Default 0.0.
#define fSaturationMultMagenta 0 //[0.00:5.00] //-Multiplies the color saturation of magenta hues only. Default 0.0.  

//>Curve Settings<\\
#define fSaturationPowRed 0 //[-1.00:5.00] //-Curves the color saturation of red hues only. Default 0.0.
#define fSaturationPowOrange 0 //[-1.00:5.00] //-Curves the color saturation of orange hues only. Default 0.0.
#define fSaturationPowYellow 0 //[-1.00:5.00] //-Curves the color saturation of yellow hues only. Default 0.0.
#define fSaturationPowGreen 0 //[-1.00:5.00] //-Curves the color saturation of green hues only. Default 0.0. 
#define fSaturationPowCyan 0 //[-1.00:5.00] //-Curves the color saturation of cyan hues only. Default 0.0.
#define fSaturationPowBlue 0 //[-1.00:5.00] //-Curves the color saturation of blue hues only. Default 0.0.
#define fSaturationPowMagenta 0 //[-1.00:5.00] //-Curves the color saturation of magenta hues only. Default 0.0. 
*/

// BUT DON'T MOVE ANYTHING ELSE BELOW THIS LINE
#ifdef USE_ENB_SETTINGS

#if ((USE_ENB_SETTINGS + USE_CUSTOM) >= 2)
  #if (USE_ENB_SETTINGS == 1)
    PARAM_ENABLE(Custom, "Custom HSV:: enabled", USE_CUSTOM, USE_CUSTOM, USE_CUSTOM)
  #else
    PARAM_ENABLE(Custom, "Custom HSV:: enabled", 0, 1, 0)
    #define USE_CUSTOM             1
  #endif

#endif

#endif


  /*-----------------------.
  | ::     Effect       :: |
  '-----------------------*/

float ColorEqualizerMod(in float H)	
{


	float SMod = 0.0;
	SMod += 0 * ( 1.0 - min( 1.0, abs( H / 0.08333333 ) ) );//red mod
	SMod += 0.03 * ( 1.0 - min( 1.0, abs( ( 0.08333333 - H ) / ( - 0.08333333 ) ) ) );//orange mod
	SMod += 0.05 * ( 1.0 - min( 1.0, abs( ( 0.16666667 - H ) / ( - 0.16666667 ) ) ) );//yellow mod
	SMod += 0 * ( 1.0 - min( 1.0, abs( ( 0.33333333 - H ) / 0.16666667 ) ) );//green mod
	SMod += 0.02 * ( 1.0 - min( 1.0, abs( ( 0.5 - H ) / 0.16666667 ) ) );//cyan mod
	SMod += 0 * ( 1.0 - min( 1.0, abs( ( 0.66666667 - H ) / 0.16666667 ) ) );//blue mod
	SMod += 0 * ( 1.0 - min( 1.0, abs( ( 0.83333333 - H ) / 0.16666667 ) ) );//magenta mod
	SMod += 0 * ( 1.0 - min( 1.0, abs( ( 1.0 - H ) / 0.16666667 ) ) );//red mod
	return SMod;
}

float ColorEqualizerMult(in float H)
{
	float SMult = 1.0;
	SMult += 0 * ( 1.0 - min( 1.0, abs( H / 0.08333333 ) ) );//red mult
	SMult += 0 * ( 1.0 - min( 1.0, abs( ( 0.08333333 - H ) / ( - 0.08333333 ) ) ) );//orange mult
	SMult += 0 * ( 1.0 - min( 1.0, abs( ( 0.16666667 - H ) / ( - 0.16666667 ) ) ) );//yellow mult
	SMult += 0 * ( 1.0 - min( 1.0, abs( ( 0.33333333 - H ) / 0.16666667 ) ) );//green mult
	SMult += 0 * ( 1.0 - min( 1.0, abs( ( 0.5 - H ) / 0.16666667 ) ) );//cyan mult
	SMult += 0 * ( 1.0 - min( 1.0, abs( ( 0.66666667 - H ) / 0.16666667 ) ) );//blue mult
	SMult += 0 * ( 1.0 - min( 1.0, abs( ( 0.83333333 - H ) / 0.16666667 ) ) );//magenta mult
	SMult += 0 * ( 1.0 - min( 1.0, abs( ( 1.0 - H ) / 0.16666667 ) ) );//red mult
	return SMult;
}

float ColorEqualizerPow(in float H)	
{
	float SPow = 1.0;
	SPow += 0 * ( 1.0 - min( 1.0, abs( H / 0.08333333 ) ) );//red pow
	SPow += 0 * ( 1.0 - min( 1.0, abs( ( 0.08333333 - H ) / ( - 0.08333333 ) ) ) );//orange pow
	SPow += 0 * ( 1.0 - min( 1.0, abs( ( 0.16666667 - H ) / ( - 0.16666667 ) ) ) );//yellow pow
	SPow += 0 * ( 1.0 - min( 1.0, abs( ( 0.33333333 - H ) / 0.16666667 ) ) );//green pow
	SPow += 0  * ( 1.0 - min( 1.0, abs( ( 0.5 - H ) / 0.16666667 ) ) );//cyan pow
	SPow += 0 * ( 1.0 - min( 1.0, abs( ( 0.66666667 - H ) / 0.16666667 ) ) );//blue pow
	SPow += 0 * ( 1.0 - min( 1.0, abs( ( 0.83333333 - H ) / 0.16666667 ) ) );//magenta pow
	SPow += 0 * ( 1.0 - min( 1.0, abs( ( 1.0 - H ) / 0.16666667 ) ) );//red pow
	return SPow;
}

float3 HUEtoRGB(in float H)
{
   	float R = abs(H * 6.0 - 3.0) - 1.0;
   	float G = 2.0 - abs(H * 6.0 - 2.0);
   	float B = 2.0 - abs(H * 6.0 - 4.0);
   	return saturate(float3(R,G,B));
}

float RGBCVtoHUE(in float3 RGB, in float C, in float V)
{
     	float3 Delta = (V - RGB) / C;
     	Delta.rgb -= Delta.brg;
     	Delta.rgb += float3(2.0,4.0,6.0);
     	Delta.brg = step(V, RGB) * Delta.brg;
     	float H;
     	H = max(Delta.r, max(Delta.g, Delta.b));
     	return frac(H / 6.0);
}

float3 HSVtoRGB(in float3 HSV)
{
   	float3 RGB = HUEtoRGB(HSV.x);
   	return ((RGB - 1) * HSV.y + 1) * HSV.z;
}
 
float3 RGBtoHSV(in float3 RGB)
{
   	float3 HSV = 0.0;
   	HSV.z = max(RGB.r, max(RGB.g, RGB.b));
   	float M = min(RGB.r, min(RGB.g, RGB.b));
   	float C = HSV.z - M;
   	if (C != 0.0)
   	{
     		HSV.x = RGBCVtoHUE(RGB, C, HSV.z);
     		HSV.y = C / HSV.z;
   	}
   	return HSV;
}

float4 CustomPass(float4 vpos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
	float4 color = tex2D(s0, texcoord.xy);

	float3 hsvcolor = RGBtoHSV( color.xyz );
	//global adjustments
	hsvcolor.x = 0 + ( 1 * pow( hsvcolor.x, 1 ) );
	hsvcolor.y = 0 + ( 1 * pow( hsvcolor.y, 1 ) );
	hsvcolor.z = 0 + ( 1 * pow( hsvcolor.z, 1 ) );
	//hue specific adjustments. Yes, hue. huehuehuehuehue.
	hsvcolor.y = ColorEqualizerMod( hsvcolor.x ) + ( ColorEqualizerMult( hsvcolor.x ) * pow( hsvcolor.y, ColorEqualizerPow( hsvcolor.x ) ) );
	hsvcolor.yz = max( hsvcolor.yz, 0.0 );
	color.xyz = HSVtoRGB( hsvcolor );

	return color;
}
